<template>
  <v-card
    min-height="250px"
    align="center"
    class="ma-auto mt-5"
    sm="10"
    md="10"
    lg="8"
    xl="8"
    cols="10"
  >
    <transition name="fade">
      <div v-if="emailSent" class="emailSentOverlay">
        <div class="check-circle">
          <v-icon x-large>mdi-check</v-icon>
        </div>
      </div>
    </transition>
    <v-card-title v-if="withHeader">
      <h2
        v-if="!$vuetify.breakpoint.mobile"
        class="ma-auto mb-5 mt-8"
        style="width: 80%"
      >
        {{ $t("subscribe_tmp.sounds_amazing") }}
      </h2>
      <p v-else class="h2-mobile ma-auto mb-5 mt-8">
        {{ $t("subscribe_tmp.sounds_amazing") }}
      </p>
    </v-card-title>
    <v-card-subtitle>
      <p
        class="ma-auto"
        :class="$vuetify.breakpoint.mobile ? 'text-mobile' : 'text'"
      >
        {{ $t("subscribe_tmp.leave_email") }}
      </p>
    </v-card-subtitle>
    <v-card-actions class="ma-auto">
      <v-row align="center" justify="center">
        <v-col
          cols="10"
          sm="10"
          md="8"
          lg="8"
          xl="8"
          align="center"
          class="pa-0"
        >
          <v-form v-model="valid">
            <CustomTextField
              :rules="[rules.required, rules.email]"
              label="E-mail"
              placeholder="example@mail.ua"
              style="margin-right: 10px"
              @change="changeEmail"
            />
          </v-form>
        </v-col>
        <v-col cols="11" class="pa-0">
          <button
            class="green-btn text-mobile mb-10"
            @click="writeUserData"
            :disabled="!valid"
            :style="valid ? '' : 'background-color: grey !important'"
          >
            {{ $t("subscribe_tmp.send") }}
          </button>
        </v-col>
      </v-row>
    </v-card-actions>
  </v-card>
</template>

<script>
import CustomTextField from "./CustomTextField";
import { initializeApp } from "firebase/app";
import { getDatabase, ref, push, set } from "firebase/database";

export default {
  components: {
    CustomTextField,
  },
  props: { userType: String, withHeader: { type: Boolean, default: true } },
  data() {
    return {
      email: "",
      rules: {
        required: (value) => !!value || this.$t("errors.required"),
        email: (value) => {
          const pattern =
            /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
          return pattern.test(value) || this.$t("errors.email");
        },
      },
      emailSent: false,
      valid: null,
    };
  },
  mounted() {
    const firebaseConfig = {
      apiKey: process.env.VUE_APP_API_KEY,
      authDomain: process.env.VUE_APP_AUTH_DOMAIN,
      databaseURL: process.env.VUE_APP_DB_URL,
      projectId: process.env.VUE_APP_PROJECT_ID,
      storageBucket: process.env.VUE_APP_STORAGE_B,
      messagingSenderId: process.env.VUE_APP_MESSAGING_ID,
      appId: process.env.VUE_APP_APP_ID,
    };
    const app = initializeApp(firebaseConfig);
    // Get a reference to the database service
    this.db = getDatabase(app);
  },
  methods: {
    async writeUserData() {
      // userType is either buyers or sellers
      const usersRef = ref(this.db, this.userType);
      const newUserRef = push(usersRef);
      try {
        await set(newUserRef, {
          email: this.email,
        });
        this.emailSent = true;
        setTimeout(() => {
          this.emailSent = false;
        }, 3000);
      } catch (err) {
        // TODO: Handle error
        console.error(err);
      }
    },
    changeEmail(value) {
      this.email = value;
    },
  },
};
</script>

<style scoped>
p,
h2 {
  text-align: center;
  word-break: normal;
}
.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.5s;
}
.fade-enter, .fade-leave-to /* .fade-leave-active below version 2.1.8 */ {
  opacity: 0;
}
.emailSentOverlay {
  background-color: rgba(255, 255, 255, 0.9);
  position: absolute;
  top: 0;
  left: 0;
  height: 100%;
  width: 100%;
  border-radius: 30px;
  z-index: 9999;
  display: flex;
  justify-content: center;
  align-items: center;
}
.check-circle {
  background-color: #7eca9c;
  border-radius: 50%;
  height: 100px;
  width: 100px;
  display: flex;
  justify-content: center;
  align-items: center;
}
.mdi-check {
  color: white;
}
</style>
